{
Pov2Tri
povray model to triangulated shape converter

program author
Arndt Kritzner, see http://www.kritzner.de

version
0.5 ... 2003-01-18

licenses:
volume3d is available under the terms of GNUs GPL (for developers of free software,
only FreePascal or GNU Pascal with Linux) or alternatively under a commercial
license (for developers of commercial software)

All rights reserved.
Any usage in another kind than described in the purchased license is prohibited.
If you want to choose the GNU GPL on another platform than GNU/Linux ask for a
free license for your preferred OS mailto:arndt@kritzner.de.

See http://www.kritzner.de/pages/v3d/v3d.html for technical and licensing details.
}

{
povparser.pp
parser functions for povray files
}

unit povparser;

interface

uses objects,triangle3d,trans3d,form3d,shape3d;


type telementtypestring = string[5];
		 tbracestring = string[1];
		 telementstring = string[255];
		
		 tfloat = double;
		 tinteger = integer;
		 tlongword = cardinal;
		 tstring = string;
		 tvector = tpoint;

     pparsobj=^tparsobj;
		 tparsobj=object(tobject)
		 					public
		 						constructor init(t_:telementtypestring;prev_:pparsobj);
		 						function move_to(t_:telementtypestring;count:byte;dir:char):pparsobj;
		 						function getnext(count:byte):pparsobj;
		 						function getnext(t_:telementtypestring;count:byte):pparsobj;
		 						function append(t_:byte;c_:telementstring):boolean; virtual;
		 						function is_expr(open_brace:boolean):boolean;
		 						function is_expr:boolean;
		 						function get_match(count:byte;m:tstring;dir:char):tstring; virtual;
		 						function get_match(count:byte;m:tstring):tstring; virtual;
		 						procedure list;
		 						procedure listcontent; virtual;
		 						procedure logcontent; virtual;
		 						function duplicate(prev_:pparsobj;count:byte):pparsobj; virtual;
		 						destructor done; virtual;
		 					private
		 						t:telementtypestring;
		 						next:pparsobj;
		 						prev:pparsobj;
		 					end;
		 					
		 tdelparsobj=record
		 							 l,r:pparsobj;
		 						 end;
		 									
     pintobj=^tintobj;
		 tintobj=object(tparsobj)
		 				 	public
		 				 		constructor init(t_:telementtypestring;prev_:pparsobj;c_:tinteger);
		 						procedure listcontent; virtual;
		 						procedure logcontent; virtual;
		 						function duplicate(prev_:pparsobj;count:byte):pparsobj; virtual;
		 				 	private
		 				 		c:tinteger;
		 					end;
		 					
		 pfloatobj=^tfloatobj;
		 tfloatobj=object(tparsobj)
		 						public
		 				 			constructor init(t_:telementtypestring;prev_:pparsobj;c_:tfloat);
			 						procedure listcontent; virtual;
  		 						procedure logcontent; virtual;
		 						  function duplicate(prev_:pparsobj;count:byte):pparsobj; virtual;
		 						private
		 							c:tfloat;
		 						end;
		 						
		 pbraceobj=^tbraceobj;
		 tbraceobj=object(tparsobj)
		 						public
		 				 			constructor init(t_:telementtypestring;prev_:pparsobj;c_:tbracestring);
			 						procedure listcontent; virtual;
  		 						procedure logcontent; virtual;
		 						  function get_match(count:byte;m:tstring;dir:char):tstring; virtual;
		 						  function duplicate(prev_:pparsobj;count:byte):pparsobj; virtual;
		 						private
		 							c:tbracestring;
		 						end;
		 						
		 pseparatorobj=^tseparatorobj;
		 tseparatorobj=object(tparsobj)
    		 						public
    		 				 			constructor init(t_:telementtypestring;prev_:pparsobj;c_:tbracestring);
    			 						procedure listcontent; virtual;
      		 						procedure logcontent; virtual;
    		 						  function get_match(count:byte;m:tstring;dir:char):tstring; virtual;
		 						      function duplicate(prev_:pparsobj;count:byte):pparsobj; virtual;
    		 						private
    		 							c:tstring;
    		 						end;
    		 						
		 pvectorobj=^tvectorobj;
		 tvectorobj=object(tparsobj)
  		 						public
  		 				 			constructor init(t_:telementtypestring;prev_:pparsobj;c_:tvector);
				 						procedure listcontent; virtual;
    		 						procedure logcontent; virtual;
		 						    function duplicate(prev_:pparsobj;count:byte):pparsobj; virtual;
  		 						private
  		 							c:tvector;
  		 						end;
		
		 ptransobj=^ttransobj;
		 ttransobj=object(tparsobj)
  		 						public
  		 				 			constructor init(t_:telementtypestring;prev_:pparsobj;tr_ro_:char;c_:tvector);
				 						procedure listcontent; virtual;
    		 						procedure logcontent; virtual;
		 						    function duplicate(prev_:pparsobj;count:byte):pparsobj; virtual;
  		 						private
  		 						  tr_ro:char;
  		 							c:tvector;
  		 						end;
		
		 potherobj=^totherobj;
		 totherobj=object(tparsobj)
		 						public
		 				 			constructor init(t_:telementtypestring;prev_:pparsobj;c_:tstring);
			 						procedure listcontent; virtual;
  		 						procedure logcontent; virtual;
		 						  function duplicate(prev_:pparsobj;count:byte):pparsobj; virtual;
		 						private
		 							c:tstring;
		 						end;
		 						
		 pv3dobj=^tv3dobj;
		 tv3dobj=object(tparsobj)
							public
								constructor init(t_:telementtypestring;prev_:pparsobj;c_:pshape_3d);
 		 						procedure listcontent; virtual;
 		 						procedure logcontent; virtual;
 	 						  function duplicate(prev_:pparsobj;count:byte):pparsobj; virtual;
 	 						  destructor done; virtual;
							private
	 							c:pshape_3d;
							end;
		 						
		 pmacro=^tmacro;
		 tmacro=object(tobject)
		        public
		          constructor init(name_:tstring;prev_:pmacro;list_:pparsobj;count:byte);
		          function by_name(name_:tstring):pmacro;
							function duplicate:pparsobj;
							function apply(instead:pparsobj):pparsobj;
							procedure listcontent; virtual;
		          destructor done; virtual;
		        private
		          name:tstring;
		          prev,next:pmacro;
		          list:pparsobj;
		        end;
		 									
function unite_v3d:pshape_3d;
function pars_new_element(element:tstring):boolean;
procedure pars_list;

implementation

type toptype=(unary,binary);

		 treduction=record
									id:word;
									r:tstring;
								end;
								
		 tmathreduction=record
		 							t:toptype;
									id:word;
									r:tstring;
								end;
								
		 toperation=record
		 							prio:byte;
		 							b:tstring;
		 						end;
	

const	as_types=16;
			as_operation=4;
			as_mathreduction=12;
			as_reductrules=22;
			as_braces=4;
			as_macroinit=33;
			as_operatn3d=18;
			as_operatn3d_=12;
			
			vec_x:tvector=(x:1;y:0;z:0);
			vec_y:tvector=(x:0;y:1;z:0);
			vec_z:tvector=(x:0;y:0;z:1);
			
			grad2rad:tfloat=pi/180;
			rad2grad:tfloat=180/pi;
			
			element_types:array[1..as_types] of telementtypestring=
				('STR','INT','FLO','ID','SET','OP','SEP','BRA','INCL','DECL','LINE','VEC','VEC2D','V3D','TRA','STOP');
				
			brace_types:array[1..as_braces,1..2] of telementtypestring=
			  (('(',')'),('[',']'),('{','}'),('<','>'));
			
			operatn:array[1..as_operation] of toperation=
				((prio:1;b:'+'),(prio:1;b:'-'),
				(prio:2;b:'*'),(prio:2;b:'/'));
				
			operatn_3d:array[1..as_operatn3d] of telementstring=
			  ('object','box','sphere','cone','cylinder','prism','plane',
			   'merge','union','difference','intersection',
			   'translate','rotate',
			   'camera','light_source','texture','finish','pigment');
			operatn_3d_ignore:set of byte=[7,14,15,16,17,18];
			operatn_3d_apply:array[1..as_operatn3d] of set of byte=([1,2],[1,2,3],[1,2,4],[1,2,5],[1,2,6],[1,2,7],
																															[],
																															[1,2,8],[1,2,8],[1,2,8],[1,2,8],
																															[],[],
																															[],[],[],[],[]
																															);
			operatn_3d_:array[1..as_operatn3d_] of treduction=
{ last steps of 3d model generation (all types of objects) }
{ direct object statement }			
			  ((id:1;r:'ID { V3D }'),(id:2;r:'ID { V3D TRA'),
{ box }
			   (id:3;r:'ID { VEC VEC'),
{ sphere }			
			   (id:4;r:'ID { VEC , NUM'),(id:4;r:'ID { VEC NUM'),
{ cone }			
			   (id:5;r:'ID { VEC , NUM VEC , NUM'),(id:5;r:'ID { VEC NUM VEC NUM'),
			   (id:5;r:'ID { VEC , NUM , VEC , NUM'),
{ cylinder }
			   (id:6;r:'ID { VEC VEC , NUM'),(id:6;r:'ID { VEC VEC NUM'),
{ prism }
			   (id:7;r:'ID { NUM , NUM , NUM , VEC2D VEC2D VEC2D'),
{ merge, union, difference, intersection }
			   (id:8;r:'ID { V3D V3D')
			  );
			
			math_reduction:array[1..as_mathreduction] of tmathreduction=
				((t:unary;id:1;r:'OP INT'),(t:unary;id:2;r:'OP FLO'),
				(t:binary;id:3;r:'INT OP INT'),(t:binary;id:4;r:'INT OP FLO'),
				(t:binary;id:5;r:'FLO OP INT'),(t:binary;id:6;r:'FLO OP FLO'),
				(t:unary;id:7;r:'OP VEC'),
				(t:binary;id:8;r:'INT OP VEC'),(t:binary;id:9;r:'VEC OP INT'),
				(t:binary;id:10;r:'FLO OP VEC'),(t:binary;id:11;r:'VEC OP FLO'),
				(t:binary;id:12;r:'VEC OP VEC'));
				
			reduct_rules:array[1..as_reductrules] of treduction=
				(
{ macro replacement }				
				(id:4;r:'ID'),
{ constant declarations }				
				(id:1;r:'DECL ID SET INT ;'),(id:2;r:'DECL ID SET FLO ;'),
				(id:5;r:'DECL ID SET VEC ;'),(id:6;r:'DECL ID SET V3D'),
{ vector elements }				
				(id:3;r:'< FLO , FLO , FLO >'),(id:3;r:'< FLO , FLO , INT >'),
				(id:3;r:'< FLO , INT , FLO >'),(id:3;r:'< FLO , INT , INT >'),
				(id:3;r:'< INT , FLO , FLO >'),(id:3;r:'< INT , FLO , INT >'),
				(id:3;r:'< INT , INT , FLO >'),(id:3;r:'< INT , INT , INT >'),
{ 2d vector elements }
				(id:7;r:'< FLO , FLO >'),(id:7;r:'< FLO , INT >'),
				(id:7;r:'< INT , FLO >'),(id:7;r:'< INT , INT >'),
{ transformation operation }				
				(id:10;r:'ID VEC'),
{ operations to perform or ignore }				
				(id:8;r:'ID {'),(id:9;r:'}'),
{ empty lines }
				(id:11;r:'LINE'),
{ includes }
				(id:12;r:'INCL STR')
				);
				
			macros_init:array[1..as_macroinit] of telementstring=
			  ('DECL:#declare','ID:x','SET:=','BRA:<','FLO:1.0','SEP:,','FLO:0.0','SEP:,','FLO:0.0','BRA:>','SEP:;',
			  'DECL:#declare','ID:y','SET:=','BRA:<','FLO:0.0','SEP:,','FLO:1.0','SEP:,','FLO:0.0','BRA:>','SEP:;',
			  'DECL:#declare','ID:z','SET:=','BRA:<','FLO:0.0','SEP:,','FLO:0.0','SEP:,','FLO:1.0','BRA:>','SEP:;'
			  );
			
var element_list:pparsobj;
		last_inserted:pparsobj;
		macro_list:pmacro;
		last_inserted_macro:pmacro;
		
procedure macro_init;
var idx:byte;
begin
  for idx:=1 to as_macroinit do
    pars_new_element(macros_init[idx]);
end;

function get_op_id(op:telementstring):byte;
var idx:byte;
{$ifndef FKT_RESULT}
    result:byte;
{$endif}
begin
  result:=0;
  for idx:=1 to as_operatn3d do
    if op=operatn_3d[idx] then
      result:=idx;
{$ifndef FKT_RESULT}
	get_op_id:=result;
{$endif}
end;

function get_num_val(o:pparsobj):tfloat;
{$ifndef FKT_RESULT}
var result:tfloat;
{$endif}
begin
  result:=0;
	if o^.t='INT' then
  	result:=pintobj(o)^.c;
	if o^.t='FLO' then
  	result:=pfloatobj(o)^.c;
{$ifndef FKT_RESULT}
	get_num_val:=result;
{$endif}
end;
		
function change_numerical(s:tstring):tstring;
var position,pos_:byte;
		piece:tstring;
{$ifndef FKT_RESULT}
		result:tstring;
{$endif}
begin
  result:='';
  position:=0;
	while position<length(s) do begin
	  pos_:=pos(' ',copy(s,position+1,length(s)));
		piece:='';
	  if pos_>1 then begin
	    piece:=copy(s,position+1,pos_-1);
	  end;
	  if pos_=0 then begin
	    piece:=copy(s,position+1,length(s));
	    position:=length(s);
	  end else begin
	  	position:=position+pos_;
	  end;
	  if piece<>'' then begin
	  	if result<>'' then
	  	  result:=result+' ';
	  	if (piece='INT') or (piece='FLO') then
	  	  piece:='NUM';
	  	result:=result+piece;
	  end;
	end;
{$ifndef FKT_RESULT}
	change_numerical:=result;
{$endif}
end;

function count_elements(s:tstring):byte;
var position,pos_:byte;
{$ifndef FKT_RESULT}
		result:byte;
{$endif}
begin
	result:=1;
	position:=0;
	while position<length(s) do begin
		pos_:=pos(' ',copy(s,position+1,length(s)));
		if pos_>1 then
		  inc(result);
		if pos_=0 then
			position:=length(s)
		else
			position:=position+pos_;
	end;
{$ifndef FKT_RESULT}
	count_elements:=result;
{$endif}
end;

function count_elements(start,stop:pparsobj):byte;
var actual:pparsobj;
{$ifndef FKT_RESULT}
		result:byte;
{$endif}
begin
	result:=1;
  actual:=start;
  while Assigned(actual) and (actual<>stop) do begin
    actual:=actual^.next;
    inc(result);
  end;
{$ifndef FKT_RESULT}
	count_elements:=result;
{$endif}
end;

function get_action_id(start:pparsobj;elemcount:byte;op_id:byte):byte;
var idx:byte;
		parse_str:tstring;
{$ifndef FKT_RESULT}
    result:byte;
{$endif}
begin
  parse_str:=change_numerical(start^.get_match(elemcount,''));
	result:=0;
	idx:=1;
	while (result=0) and (idx<=as_operatn3d_) do begin
		if (operatn_3d_[idx].id in operatn_3d_apply[op_id]) and (pos(operatn_3d_[idx].r,parse_str)=1) then
		  result:=operatn_3d_[idx].id;
	  Inc(idx);
	end;
{$ifndef FKT_RESULT}
	get_action_id:=result;
{$endif}
end;

function del_chain(start:pparsobj;stop:pparsobj):tdelparsobj;
{$ifndef FKT_RESULT}
var	result:tdelparsobj;
{$endif}
begin
	result.l:=start^.prev;
	result.r:=stop^.next;
  if start=element_list then begin
    element_list:=stop^.next;
    last_inserted:=element_list;
  end;
  if Assigned(start^.prev) then
    start^.prev^.next:=stop^.next;
  if Assigned(stop^.next) then
    stop^.next^.prev:=start^.prev;
  stop^.next:=nil;
  dispose(start,done);
{$ifndef FKT_RESULT}
	del_chain:=result;
{$endif}
end;

procedure add_chain(actual:pparsobj;new_elem:pparsobj;dir:char);
begin
  if Assigned(actual) then
    case dir of
      '>':begin
      			new_elem^.next:=actual^.next;
      			new_elem^.prev:=actual;
      			actual^.next:=new_elem;
      			if Assigned(new_elem^.next) then
      			  new_elem^.next^.prev:=new_elem;
      		end;
      '<':begin
            new_elem^.next:=actual;
            new_elem^.prev:=actual^.prev;
            actual^.prev:=new_elem;
            if Assigned(new_elem^.prev) then
              new_elem^.prev^.next:=new_elem
            else
              element_list:=new_elem;
      		end;
    end
  else begin
    element_list:=new_elem;
  end;
  last_inserted:=new_elem;
end;

function unite_v3d:pshape_3d;
var actual:pparsobj;
		error:boolean;
{$ifndef FKT_RESULT}
    result:pshape_3d;
{$endif}
begin
	result:=nil;
	error:=false;
	actual:=element_list;
	while Assigned(actual) and (not error) do begin
	  if actual^.t='V3D' then begin
			if not Assigned(result) then
			  result:=new(pshape_3d,init(sizeof(ttrianglearray) div sizeof(ptriangle)));
	    if not result^.include_triangles(pv3dobj(actual)^.c) then
	    	error:=true;
	  end;
		actual:=actual^.next;
	end;
	if error then begin
	  dispose(result,done);
	  result:=nil;
	end;
{$ifndef FKT_RESULT}
  unite_v3d:=result;
{$endif}
end;

function math_reduce(fkt_id:word;position:pparsobj;prio:byte):pparsobj;
var idx,idx_,count:byte;
		start,stop,operation,new_elem:pparsobj;
		opcode:tstring;
		v:tvector;
{$ifndef FKT_RESULT}
   	result:pparsobj;
{$endif}
begin
{$ifdef Log}
	if TriLog then
		WriteLN(StdErr,'math_reduce');
{$endif}
	result:=Nil;
	idx:=1;
	while (idx<=as_mathreduction) and (math_reduction[idx].id<>fkt_id) do
		inc(idx);
	if idx<=as_mathreduction then begin
		count:=count_elements(math_reduction[idx].r);
		start:=position;
		stop:=start^.getnext(count);
		operation:=start^.getnext('OP',count);
		opcode:=potherobj(operation)^.c;
		idx_:=1;
		while (idx_<=as_operation) and (opcode<>operatn[idx_].b) do
			inc(idx_);
		if idx_<=as_operation then
			if (prio=0) or (operatn[idx_].prio=prio) then begin
				new_elem:=Nil;
				case idx_ of
{ +}					
					1:case fkt_id of
							3:new_elem:=New(pintobj,init('INT',start^.prev,pintobj(start)^.c+pintobj(stop)^.c));
							4:new_elem:=New(pfloatobj,init('FLO',start^.prev,pintobj(start)^.c+pfloatobj(stop)^.c));
							5:new_elem:=New(pfloatobj,init('FLO',start^.prev,pfloatobj(start)^.c+pintobj(stop)^.c));
							6:new_elem:=New(pfloatobj,init('FLO',start^.prev,pfloatobj(start)^.c+pfloatobj(stop)^.c));
							12:begin
									 v.x:=pvectorobj(start)^.c.x+pvectorobj(stop)^.c.x;
									 v.y:=pvectorobj(start)^.c.y+pvectorobj(stop)^.c.y;
									 v.z:=pvectorobj(start)^.c.z+pvectorobj(stop)^.c.z;
							     new_elem:=New(pvectorobj,init('VEC',start^.prev,v));
							   end;
					  end;
{ -}					
					2:case fkt_id of
							1:new_elem:=New(pintobj,init('INT',start^.prev,-pintobj(stop)^.c));
							2:new_elem:=New(pfloatobj,init('FLO',start^.prev,-pfloatobj(stop)^.c));
							3:new_elem:=New(pintobj,init('INT',start^.prev,pintobj(start)^.c-pintobj(stop)^.c));
							4:new_elem:=New(pfloatobj,init('FLO',start^.prev,pintobj(start)^.c-pfloatobj(stop)^.c));
							5:new_elem:=New(pfloatobj,init('FLO',start^.prev,pfloatobj(start)^.c-pintobj(stop)^.c));
							6:new_elem:=New(pfloatobj,init('FLO',start^.prev,pfloatobj(start)^.c-pfloatobj(stop)^.c));
							7:begin
									 v.x:=-pvectorobj(stop)^.c.x;
									 v.y:=-pvectorobj(stop)^.c.y;
									 v.z:=-pvectorobj(stop)^.c.z;
							     new_elem:=New(pvectorobj,init('VEC',start^.prev,v));
							   end;
							12:begin
									 v.x:=pvectorobj(start)^.c.x-pvectorobj(stop)^.c.x;
									 v.y:=pvectorobj(start)^.c.y-pvectorobj(stop)^.c.y;
									 v.z:=pvectorobj(start)^.c.z-pvectorobj(stop)^.c.z;
							     new_elem:=New(pvectorobj,init('VEC',start^.prev,v));
							   end;
					  end;
{ *}					
					3:case fkt_id of
							3:new_elem:=New(pintobj,init('INT',start^.prev,pintobj(start)^.c*pintobj(stop)^.c));
							4:new_elem:=New(pfloatobj,init('FLO',start^.prev,pintobj(start)^.c*pfloatobj(stop)^.c));
							5:new_elem:=New(pfloatobj,init('FLO',start^.prev,pfloatobj(start)^.c*pintobj(stop)^.c));
							6:new_elem:=New(pfloatobj,init('FLO',start^.prev,pfloatobj(start)^.c*pfloatobj(stop)^.c));
							8:begin
									v.x:=pintobj(start)^.c*pvectorobj(stop)^.c.x;
									v.y:=pintobj(start)^.c*pvectorobj(stop)^.c.y;
									v.z:=pintobj(start)^.c*pvectorobj(stop)^.c.z;
							    new_elem:=New(pvectorobj,init('VEC',start^.prev,v));
							  end;
							9:begin
									v.x:=pvectorobj(start)^.c.x*pintobj(stop)^.c;
									v.y:=pvectorobj(start)^.c.y*pintobj(stop)^.c;
									v.z:=pvectorobj(start)^.c.z*pintobj(stop)^.c;
							    new_elem:=New(pvectorobj,init('VEC',start^.prev,v));
							  end;
							10:begin
									 v.x:=pfloatobj(start)^.c*pvectorobj(stop)^.c.x;
									 v.y:=pfloatobj(start)^.c*pvectorobj(stop)^.c.y;
									 v.z:=pfloatobj(start)^.c*pvectorobj(stop)^.c.z;
							     new_elem:=New(pvectorobj,init('VEC',start^.prev,v));
							   end;
							11:begin
									 v.x:=pvectorobj(start)^.c.x*pfloatobj(stop)^.c;
									 v.y:=pvectorobj(start)^.c.y*pfloatobj(stop)^.c;
									 v.z:=pvectorobj(start)^.c.z*pfloatobj(stop)^.c;
							     new_elem:=New(pvectorobj,init('VEC',start^.prev,v));
							   end;
					  end;
{ /}					
					4:case fkt_id of
							3:new_elem:=New(pfloatobj,init('FLO',start^.prev,pintobj(start)^.c/pintobj(stop)^.c));
							4:new_elem:=New(pfloatobj,init('FLO',start^.prev,pintobj(start)^.c/pfloatobj(stop)^.c));
							5:new_elem:=New(pfloatobj,init('FLO',start^.prev,pfloatobj(start)^.c/pintobj(stop)^.c));
							6:new_elem:=New(pfloatobj,init('FLO',start^.prev,pfloatobj(start)^.c/pfloatobj(stop)^.c));
							9:begin
									v.x:=pvectorobj(start)^.c.x/pintobj(stop)^.c;
									v.y:=pvectorobj(start)^.c.y/pintobj(stop)^.c;
									v.z:=pvectorobj(start)^.c.z/pintobj(stop)^.c;
							    new_elem:=New(pvectorobj,init('VEC',start^.prev,v));
							  end;
							11:begin
									 v.x:=pvectorobj(start)^.c.x/pfloatobj(stop)^.c;
									 v.y:=pvectorobj(start)^.c.y/pfloatobj(stop)^.c;
									 v.z:=pvectorobj(start)^.c.z/pfloatobj(stop)^.c;
							     new_elem:=New(pvectorobj,init('VEC',start^.prev,v));
							   end;
						end;
				end;
				if Assigned(new_elem) then begin
					if Assigned(start^.prev) then
						start^.prev^.next:=new_elem
					else
						element_list:=new_elem;
					new_elem^.next:=stop^.next;
					if Assigned(stop^.next) then
						stop^.next^.prev:=new_elem;
					stop^.next:=Nil;
					Dispose(start,done);
					last_inserted:=new_elem^.getnext(0);
					result:=new_elem;
				end;
			end;
	end;
{$ifndef FKT_RESULT}
	math_reduce:=result;
{$endif}
end;

function math_reduce(fkt_id:word;position:pparsobj):pparsobj;
begin
	math_reduce:=math_reduce(fkt_id,position,0);
end;

procedure reduce_math(stop:pparsobj);
var lpop,mpop:byte;
		idx,idx_,forw_binary:word;
		start:pparsobj;
		fin,reduced:boolean;
		position,position_:pparsobj;

function math_start_stop(position:pparsobj;dir:char):pparsobj;
var fin:boolean;
{$ifndef FKT_RESULT}
   	result:pparsobj;
{$endif}
begin
	result:=nil;
	if assigned(position) then
		case dir of
			'<':begin
          	fin:=false;
          	result:=position;
          	while not fin do begin
          		fin:=true;
          		if assigned(result^.prev) then
          			if result^.prev^.is_expr then begin
          				result:=result^.prev;
          				fin:=false;
{$ifdef Log}
  								if TriLog then begin		
          					Write(StdErr,'start <<== ');
          					result^.listcontent;
          					WriteLN(StdErr);
          				end;
{$endif}	
          			end;
          	end;
					end;
			'>':begin
          	fin:=false;
          	result:=position;
          	while not fin do begin
          		fin:=true;
          		if assigned(result^.next) then
          			if result^.next^.is_expr then begin
          				result:=result^.next;
          				fin:=false;
{$ifdef Log}
  								if TriLog then begin		
          					Write(StdErr,'stop ==>> ');
          					result^.listcontent;
          					WriteLN(StdErr);
          				end;
{$endif}	
          			end;
          	end;
					end;
		end;
{$ifndef FKT_RESULT}
	math_start_stop:=result;
{$endif}
end;

begin
{$ifdef Log}
	if TriLog then
		WriteLN(StdErr,'reduce_math');
{$endif}	
	if Assigned(stop) then begin
  	lpop:=operatn[1].prio;
  	mpop:=operatn[1].prio;
  	if as_operation>1 then
  		for idx:=2 to as_operation do begin
  			if operatn[idx].prio>mpop then
  				mpop:=operatn[idx].prio;
  			if operatn[idx].prio<lpop then
  				lpop:=operatn[idx].prio;
  		end;
{$ifdef Log}
		if TriLog then
			WriteLN(StdErr,'lpop: ',lpop,', mpop: ',mpop);
{$endif}	
  	start:=math_start_stop(stop,'<');
  	fin:=false;
  	while not fin do begin
  		fin:=true;
    	for idx:=mpop+1 downto lpop do begin
{$ifdef Log}
				if TriLog then
					WriteLN(StdErr,'prio: ',idx);
{$endif}	
    		position:=start;
    		forw_binary:=0;
    		while position<>stop do begin
    			idx_:=1;
    			while idx_<=as_mathreduction do begin
    				reduced:=false;
    				with math_reduction[idx_] do begin
{$ifdef Log}
							if TriLog then begin		
								WriteLN(StdErr,'r: ',r,' =? get_match: ',position^.get_match(count_elements(r),''));
								WriteLN(StdErr,'count_elements(r): ',count_elements(r));
							end;
{$endif}	
    	  		  if idx>mpop then begin
      					if t=unary then begin
        					if forw_binary=0 then begin
        						if r=position^.get_match(count_elements(r),'') then begin
        							position_:=math_reduce(id,position);
        							if Assigned(position_) then begin
        								reduced:=true;
        								position:=position_;
        								start:=math_start_stop(position,'<');
        								stop:=math_start_stop(position,'>');
{$ifdef Log}
												if TriLog then
  												if Assigned(element_list) then
  													element_list^.list;
{$endif}	
        							end;
        							if (idx<lpop) and reduced then
        								fin:=false;
        						end;
        					end;
      					end else begin
       						if r=position^.get_match(count_elements(r),'') then
       							if count_elements(r)>forw_binary then
       								forw_binary:=count_elements(r);
      					end;
      				end else
      					if (t=binary) then
      						if r=position^.get_match(count_elements(r),'') then begin
      							position_:=math_reduce(id,position,idx);
      							if Assigned(position_) then begin
      								reduced:=true;
      								position:=position_;
      								start:=math_start_stop(position,'<');
      								stop:=math_start_stop(position,'>');
{$ifdef Log}
											if TriLog then
												if Assigned(element_list) then
													element_list^.list;
{$endif}	
      							end;
      						end;
      			end;
      			if reduced then
      				idx_:=succ(as_mathreduction)
      			else
      				inc(idx_);
    			end;
    			if not reduced then begin
    		  	position:=position^.next;
    		  	if forw_binary>0 then
    		  	  dec(forw_binary);
    		  end;
    		end;
    	end;
    end;
	end;
end;

procedure reduce_brace(stop:pparsobj);
var start,stop_:pbraceobj;
		match_str:string;
begin
{$ifdef Log}
	if TriLog then
		WriteLN('reduce_brace:');
{$endif}	
	if Assigned(stop) then begin
		start:=Nil;
		if stop^.t='BRA' then begin
			if Assigned(stop^.prev) then
				start:=pbraceobj(stop^.prev^.move_to('BRA',2,'<'));
			stop_:=pbraceobj(stop);
{$ifdef Log}
  		if TriLog then begin		
  			if Assigned(start) then
  				WriteLN(STDERR,'reduce_brace: start:',start^.t,'|',start^.c,'|');
  			if Assigned(stop_) then
  				WriteLN(STDERR,'reduce_brace: stop:',stop_^.t,'|',stop_^.c,'|');
  		end;
{$endif}	
		end;
		if Assigned(start) then begin
			if (start^.c='(') and (stop_^.c=')') then begin
				match_str:=pparsobj(start)^.get_match(3,'');
				if (match_str='( INT )') or (match_str='( FLO )') then begin
{$ifdef Log}
  				if TriLog then
     				Write(STDERR,'reduce_brace:');
{$endif}	
					if Assigned(start^.prev) then begin
						start^.prev^.next:=start^.next;
{$ifdef Log}
						if TriLog then
     					Write(STDERR,' start^.prev:',start^.prev^.t);
{$endif}	
					end else
					  element_list:=start^.next;
{$ifdef Log}
					if TriLog then
   					Write(STDERR,' start:',start^.t,' start^.next:',start^.next^.t);
{$endif}	
					start^.next^.prev:=start^.prev;
					
{$ifdef Log}
					if TriLog then
   					Write(STDERR,'reduce_brace: stop^.prev:',stop^.prev^.t,' stop:',stop^.t);
{$endif}	
					if Assigned(stop^.next) then begin
						stop^.next^.prev:=stop^.prev;
{$ifdef Log}
						if TriLog then
	     				Write(STDERR,' stop^.next:',stop^.next^.t);
{$endif}	
					end;
{$ifdef Log}
					if TriLog then
   					WriteLN(STDERR);
{$endif}	
					stop^.prev^.next:=stop^.next;
					start^.next:=Nil;
					dispose(start,done);
					stop^.next:=Nil;
					dispose(stop,done);
{$ifdef Log}
					if TriLog then
						if Assigned(element_list) then
  						element_list^.list;
{$endif}	
				end;
			end;
		end;
	end;
end;

function matches_id(position:pparsobj;id:byte):byte;
var idx,elemcount,matchlen:byte;
{$ifndef FKT_RESULT}
    result:byte;
{$endif}
begin
  result:=0;
  matchlen:=0;
  for idx:=1 to as_reductrules do begin
		elemcount:=count_elements(reduct_rules[idx].r);
		if position^.get_match(elemcount,'','<')=reduct_rules[idx].r then
		  if elemcount>matchlen then begin
		    result:=idx;
		    matchlen:=elemcount;
		  end;
	end;
{$ifndef FKT_RESULT}
	matches_id:=result;
{$endif}
end;

function match_brace(position:pparsobj):pparsobj;
var brace_type,idx,bracelevel:byte;
		dir:char;
    this,correspond:telementtypestring;
    actual:pparsobj;
{$ifndef FKT_RESULT}
    result:pparsobj;
{$endif}
begin
{$ifdef Log}
	if TriLog then
		WriteLN(STDERR,'match brace');
{$endif}
  result:=nil;
  brace_type:=0;
  if position^.t='BRA' then
    for idx:=1 to 2*as_braces do
      if brace_types[((idx-1) mod as_braces)+1,((idx-1) div as_braces)+1]=pbraceobj(position)^.c then
        brace_type:=idx;
  if brace_type>0 then begin
    if brace_type>as_braces then begin
      this:=brace_types[((brace_type-1) mod as_braces)+1,2];
      correspond:=brace_types[((brace_type-1) mod as_braces)+1,1];
      dir:='<';
    end else begin
      this:=brace_types[((brace_type-1) mod as_braces)+1,1];
      correspond:=brace_types[((brace_type-1) mod as_braces)+1,2];
      dir:='>';
    end;
    bracelevel:=1;
		actual:=position^.move_to('',2,dir);
		while Assigned(actual) and (bracelevel>0) do begin
		  if actual^.t='BRA' then
		    if pbraceobj(actual)^.c=correspond then
		      dec(bracelevel)
		    else
  		    if pbraceobj(actual)^.c=this then
  		      inc(bracelevel);
  		if bracelevel>0 then
    		actual:=actual^.move_to('',2,dir);
		end;
	  if bracelevel=0 then
	    result:=actual;
  end;
{$ifndef FKT_RESULT}
	match_brace:=result;
{$endif}
end;

function reduce_operation(position:pparsobj;fkt_id:word):boolean;
var test_idx,elemid,elemcount:byte;
    stop,reduce:boolean;
    start:pparsobj;
    actual:array[1..3] of pparsobj;
    new_elem:pvectorobj;
    new_elem_:ptransobj;
    new_3d_elem:pv3dobj;
    v,v_:tvector;
    r,r_:tfloat;
    d:float3d;
    shape:pshape_3d;
    macro:pmacro;
    op_id,actn_id:byte;
    poly:ppoly;
    idx:poly_idx3d;
{$ifndef FKT_RESULT}
		result:boolean;
{$endif}
begin
  result:=false;
  test_idx:=1;
  start:=nil;
  stop:=false;
  while (not stop) and (test_idx<=as_reductrules) do begin
    if reduct_rules[test_idx].id=fkt_id then
      stop:=true
    else
      inc(test_idx);
  end;
  if stop then begin
    if Assigned(position) then
      start:=position^.move_to('',count_elements(reduct_rules[test_idx].r),'<');
    if Assigned(start) then
    	case fkt_id of
{macro declarations}    	
    	  1,2,5,6:begin
{$ifdef Log}
  								if TriLog then begin		
          	    		Write(STDERR,'reduce_operation (macro): start:',start^.t,'|');
          	    		start^.logcontent;
          	    		WriteLN(STDERR,'|');
          			    Write(STDERR,'reduce_operation (macro): stop:',position^.t,'|');
          			    position^.logcontent;
          			    WriteLN(STDERR,'|');
          			  end;
{$endif}
      						last_inserted_macro:=new(pmacro,init(potherobj(start^.next)^.c,last_inserted_macro,start^.move_to('',4,'>'),1));	
      						if not Assigned(macro_list) then
      						  macro_list:=last_inserted_macro;
				      		del_chain(start,position);
        					result:=true;
          	    end;
{vector objects}    	
    	  3,7:begin
{$ifdef Log}
  						if TriLog then begin		
      	    		Write(STDERR,'reduce_operation (vector): start:',start^.t,'|');
      	    		start^.logcontent;
      	    		WriteLN(STDERR,'|');
      			    Write(STDERR,'reduce_operation (vector): stop:',position^.t,'|');
      			    position^.logcontent;
      			    WriteLN(STDERR,'|');
      			  end;
{$endif}	
      	  		actual[1]:=start;
      	  		actual[1]:=actual[1]^.move_to('',2,'>');
      	  		v.x:=get_num_val(actual[1]);
      	  		actual[1]:=actual[1]^.move_to('',3,'>');
      	  		v.y:=get_num_val(actual[1]);
      	  		if fkt_id=3 then begin
      	  		  actual[1]:=actual[1]^.move_to('',3,'>');
      	  		  v.z:=-get_num_val(actual[1]);
    					  new_elem:=New(pvectorobj,init('VEC',Nil,v));
      	  		end else begin
      	  		  v.z:=0;
    					  new_elem:=New(pvectorobj,init('VEC2D',Nil,v));
      	  		end;
     				  add_chain(start,new_elem,'<');
				      del_chain(start,position);
    					result:=true;
      	    end;
{apply macros}    	
    	  4:if Assigned(macro_list) then begin
    	      macro:=macro_list^.by_name(potherobj(position)^.c);
    	      if Assigned(macro) then begin
    					macro^.apply(position);
    					result:=true;
    	      end;
    	    end;
{transformation operations}    	
    	  10:begin
    	       op_id:=get_op_id(potherobj(start)^.c);
      	     if op_id in [12,13] then begin
{$ifdef Log}
  						 if TriLog then begin		
        	    	 Write(STDERR,'reduce_operation (transformation): start:',start^.t,'|');
        	    	 start^.logcontent;
        	    	 WriteLN(STDERR,'|');
        			   Write(STDERR,'reduce_operation (transformation): stop:',position^.t,'|');
       	 		     position^.logcontent;
       		 	     WriteLN(STDERR,'|');
       		 	   end;
{$endif}
        	  	 actual[1]:=start;
        	  	 actual[1]:=actual[1]^.move_to('',2,'>');
        	  	 if op_id=12 then
      					 new_elem_:=New(ptransobj,init('TRA',Nil,'t',pvectorobj(actual[1])^.c))
        	  	 else
      					 new_elem_:=New(ptransobj,init('TRA',Nil,'r',pvectorobj(actual[1])^.c));
      				 add_chain(start,new_elem_,'<');
					     del_chain(start,position);
      				 result:=true;
      	     end;
    	     end;
{ignore empty source line}
    	  11:begin
					   del_chain(start,start);
					   result:=true;
    	  	 end;	
{ignore includes}
				12:begin
					   del_chain(start,position);
					   result:=true;
				   end;
{perform or ignore operations}    	
    	  9:begin
    	      actual[1]:=match_brace(position);
    	      if Assigned(actual[1]) then begin
    	        elemid:=matches_id(actual[1],8);
    	        if elemid>0 then begin
    	          start:=actual[1]^.move_to('',count_elements(reduct_rules[elemid].r),'<');
    	          if Assigned(start) then
      						op_id:=get_op_id(potherobj(start)^.c)
      					else
      					  op_id:=0;
      					if op_id>0 then begin
        					if op_id in operatn_3d_ignore then begin {operations to ignore}
{$ifdef Log}
  									if TriLog then begin		
             	    		Write(STDERR,'reduce_operation (ignore {}): start:',start^.t,'|');
             	    		start^.logcontent;
             	    		WriteLN(STDERR,'|');
             			    Write(STDERR,'reduce_operation (ignore {}): stop:',position^.t,'|');
             			    position^.logcontent;
             			    WriteLN(STDERR,'|');
             			  end;
{$endif}
								    del_chain(start,position);
          					result:=true;
        					end else begin {operations to perform}
{$ifdef Log}
  									if TriLog then begin		
             	    		Write(STDERR,'reduce_operation (perform {3D}): start:',start^.t,'|');
             	    		start^.logcontent;
             	    		WriteLN(STDERR,'|');
             			    Write(STDERR,'reduce_operation (perform {3D}): stop:',position^.t,'|');
             			    position^.logcontent;
             			    WriteLN(STDERR,'|');
             			  end;
{$endif}
										reduce:=true;
										while reduce do begin
											reduce:=false;
  										elemcount:=count_elements(start,position);
											actn_id:=get_action_id(start,elemcount,op_id);
{$ifdef Log}
											if TriLog then
	             	    		WriteLN(STDERR,'action id: ',actn_id,' operation id: ',op_id);
{$endif}
											if actn_id>0 then
  											case actn_id of
{final step of 3d object generation}  												
  												1:begin
{$ifdef Log}
															if TriLog then
                    	    			WriteLN(STDERR,'anchor 3D object');
{$endif}
  														start:=del_chain(start,start^.next).r;
  														position:=del_chain(position,position).l;
 														  Writeln('3D Object anchored: ',pv3dobj(start)^.c^.name);
 														  reduce:=true;
  												  end;
{3d object transformation}  												
  												2:begin
{$ifdef Log}
															if TriLog then
	                    	    		WriteLN(STDERR,'3D transformation');
{$endif}
  												    actual[1]:=start^.move_to('TRA',4,'>');
  												    with ptransobj(actual[1])^ do begin
    												    case tr_ro of
    												    	'r':begin
    												    				rotate(0,0,0,c.x,c.y,c.z,vec_len(c)*grad2rad,pv3dobj(actual[1]^.prev)^.c);
    												    				del_chain(actual[1],actual[1]);
			    														  Writeln('3D Object rotated: ',c.x:0:4,',',c.y:0:4,',',c.z:0:4);
			    														  reduce:=true;
    												    			end;
    												    	't':begin
    												    				translate(c.x,c.y,c.z,pv3dobj(actual[1]^.prev)^.c);
			    														  Writeln('3D Object translated: ',c.x:0:4,',',c.y:0:4,',',c.z:0:4);
    												    				del_chain(actual[1],actual[1]);
			    														  reduce:=true;
    												    			end;
    												    end;
  												    end;
  												  end;
{box}  												
  												3:case op_id of
    												  2:begin
{$ifdef Log}
																	if TriLog then
                        	    			WriteLN(STDERR,'box creation');
{$endif}
      														actual[1]:=start^.move_to('VEC',3,'>');
    														  new_3d_elem:=new(pv3dobj,init('V3D',NIL,
    														  	box(pvectorobj(actual[1])^.c,pvectorobj(actual[1]^.next)^.c,'box',12)));
    														  Writeln('3D Box added: <',pvectorobj(actual[1])^.c.x:0:4,',',pvectorobj(actual[1])^.c.y:0:4,',',
    														  	pvectorobj(actual[1])^.c.z:0:4,'> <',pvectorobj(actual[1]^.next)^.c.x:0:4,',',
    														  	pvectorobj(actual[1]^.next)^.c.y:0:4,',',pvectorobj(actual[1]^.next)^.c.z:0:4,'>');
    														  add_chain(actual[1],new_3d_elem,'<');
    														  del_chain(actual[1],actual[1]^.next);
    														  reduce:=true;
    													  end;
  												  end;
{sphere}
  												4:case op_id of
  														3:begin
{$ifdef Log}
																	if TriLog then
	                        	    		WriteLN(STDERR,'sphere creation');
{$endif}
  																actual[2]:=start^.move_to('FLO',5,'>');
  																if not Assigned(actual[2]) then
  																  actual[2]:=start^.move_to('INT',5,'>');
  																shape:=sphere(get_num_val(actual[2]),'sphere',sizeof(ttrianglearray) div sizeof(ptriangle));
  																shape^.change_size(cl_minimize);
  																actual[1]:=start^.move_to('VEC',3,'>');
  																with pvectorobj(actual[1])^ do
  																	translate(c.x,c.y,c.z,shape);
  																new_3d_elem:=new(pv3dobj,init('V3D',NIL,shape));
    														  WriteLN('3D Sphere added: <',pvectorobj(actual[1])^.c.x:0:4,',',pvectorobj(actual[1])^.c.y:0:4,',',
    														  	pvectorobj(actual[1])^.c.z:0:4,'> r=',get_num_val(actual[2]):0:4);
  																add_chain(actual[1],new_3d_elem,'<');
  																del_chain(actual[1],actual[2]);
  																reduce:=true;
  														  end;
  												  end;
{cone}
													5:case op_id of
															4:begin
{$ifdef Log}
																	if TriLog then
	                        	    		WriteLN(STDERR,'cone creation');
{$endif}
  																actual[1]:=start^.move_to('VEC',3,'>');
  																v:=pvectorobj(actual[1])^.c;
  																actual[2]:=actual[1]^.move_to('FLO',3,'>');
  																if not Assigned(actual[2]) then
  																	actual[2]:=actual[1]^.move_to('INT',3,'>');
  																r:=get_num_val(actual[2]);
  																actual[2]:=actual[2]^.move_to('VEC',3,'>');
  																v_:=pvectorobj(actual[2])^.c;
  																actual[3]:=actual[2]^.move_to('FLO',3,'>');
  																if not Assigned(actual[3]) then
  																	actual[3]:=actual[2]^.move_to('INT',3,'>');
  																r_:=get_num_val(actual[3]);
  																d:=vec_len(point_point(v,v_));
  																if d>0 then begin
																		shape:=cone(r,r_,d,'cone',sizeof(ttrianglearray) div sizeof(ptriangle));
  																	shape^.change_size(cl_minimize);
  																	with trans(point(0,0,d),point_point(v,v_)) do
  																		rotate(0,0,0,axis.x,axis.y,axis.z,angle,shape);
  																	translate(v.x,v.y,v.z,shape);
    																new_3d_elem:=new(pv3dobj,init('V3D',NIL,shape));
      														  WriteLN('3D Cone added: <',v.x:0:4,',',v.y:0:4,',',v.z:0:4,'> r=',r:0:4,
      														  	' <',v_.x:0:4,',',v_.y:0:4,',',v_.z:0:4,'> r=',r_:0:4);
    																add_chain(actual[1],new_3d_elem,'<');
  																end else
      														  WriteLN('3D Cone ignored because of no height.');
   																del_chain(actual[1],actual[3]);
  																reduce:=true;
															  end;
													  end;
{cylinder}
													6:case op_id of
															5:begin
{$ifdef Log}
																	if TriLog then
	                        	    		WriteLN(STDERR,'cylinder creation');
{$endif}
  																actual[1]:=start^.move_to('VEC',3,'>');
  																v:=pvectorobj(actual[1])^.c;
  																actual[2]:=actual[1]^.next^.move_to('VEC',1,'>');
  																v_:=pvectorobj(actual[2])^.c;
  																actual[3]:=actual[2]^.move_to('FLO',3,'>');
  																if not Assigned(actual[3]) then
  																	actual[3]:=actual[2]^.move_to('INT',3,'>');
  																r:=get_num_val(actual[3]);
  																d:=vec_len(point_point(v,v_));
  																if d>0 then begin
																		shape:=cylinder(r,d,'cylinder',sizeof(ttrianglearray) div sizeof(ptriangle));
  																	shape^.change_size(cl_minimize);
  																	with trans(point(0,0,d),point_point(v,v_)) do
  																		rotate(0,0,0,axis.x,axis.y,axis.z,angle,shape);
  																	translate(v.x,v.y,v.z,shape);
    																new_3d_elem:=new(pv3dobj,init('V3D',NIL,shape));
      														  WriteLN('3D Cylinder added: <',v.x:0:4,',',v.y:0:4,',',v.z:0:4,
      														  	'> <',v_.x:0:4,',',v_.y:0:4,',',v_.z:0:4,'> r=',r:0:4);
    																add_chain(actual[1],new_3d_elem,'<');
  																end else
      														  WriteLN('3D Cone ignored because of no height.');
   																del_chain(actual[1],actual[3]);
  																reduce:=true;
																end;
													  end;
{prism}
													7:case op_id of
															6:begin
{$ifdef Log}
																	if TriLog then
	                        	    		WriteLN(STDERR,'prism creation');
{$endif}
																	actual[1]:=start^.move_to('FLO',3,'>');
  																if not Assigned(actual[1]) then
  																	actual[1]:=start^.move_to('INT',3,'>');
  																v.x:=0; v.y:=0; v.z:=-get_num_val(actual[1]);
																	actual[2]:=actual[1]^.next^.move_to('FLO',2,'>');
  																if not Assigned(actual[2]) then
  																	actual[2]:=actual[1]^.next^.move_to('INT',2,'>');
  																v_.x:=0; v_.y:=0; v_.z:=-get_num_val(actual[2]);
																	actual[2]:=actual[2]^.next^.move_to('INT',2,'>');
																	if (v.z<>v_.z) and assigned(actual[2]) then begin
																		poly:=create_poly(pintobj(actual[2])^.c);
																		actual[3]:=actual[2];
																		for idx:=1 to pintobj(actual[2])^.c do begin
																		  if assigned(actual[3]) then
																		    if assigned(actual[3]^.next) then
  																				actual[3]:=actual[3]^.next^.move_to('VEC2D',2,'>')
  																			else
  																				actual[3]:=nil;
																		  if assigned(actual[3]) then
  																			poly^[idx-1]:=pvectorobj(actual[3])^.c;
  																	end;
  																	if assigned(actual[3]) then begin
  																		shape:=prism(v.z,v_.z,pintobj(actual[2])^.c,poly,'prism',
  																			sizeof(ttrianglearray) div sizeof(ptriangle));
	  																	shape^.change_size(cl_minimize);
      																new_3d_elem:=new(pv3dobj,init('V3D',NIL,shape));
        														  Write('3D Prism added: h=',v.z:0:4,'...',v_.z:0:4,
        														  	', points=',pintobj(actual[2])^.c);
        														  for idx:=1 to pintobj(actual[2])^.c do
        														    Write(' <',poly^[idx-1].x:0:4,',',poly^[idx-1].y:0:4,',',poly^[idx-1].z:0:4,'>');
        														  Writeln();
      																add_chain(actual[1],new_3d_elem,'<');
      																del_chain(actual[1],actual[3]);
      																reduce:=true;
  																	end else
        														  WriteLN('3D Error in prism definition.');
  																	poly:=free_poly(poly,pintobj(actual[2])^.c);
																	end else
      														  WriteLN('3D Error in prism definition.');
															  end;
													  end;
{merge, union, difference, intersection}
													8:case op_id of
{merge,union}
															8,9:begin
{$ifdef Log}
																		if TriLog then
	                          	    		WriteLN(STDERR,'merge/union');
{$endif}
  																	actual[1]:=start^.move_to('V3D',3,'>');
  																	actual[2]:=actual[1]^.next^.move_to('V3D',1,'>');
  																	pv3dobj(actual[1])^.c^.change_size(cl_maximize);
  																	pv3dobj(actual[2])^.c^.change_size(cl_maximize);
  																	shape:=add_shape(pv3dobj(actual[1])^.c,pv3dobj(actual[2])^.c);
  																	if Assigned(shape) then begin
    																	pv3dobj(actual[1])^.c:=NIL;
    																	pv3dobj(actual[2])^.c:=NIL;
       																new_3d_elem:=new(pv3dobj,init('V3D',NIL,shape));
        														  WriteLN('3D Objects added: ',shape^.name);
       																add_chain(actual[1],new_3d_elem,'<');
     																end;
     																del_chain(actual[1],actual[2]);
     																reduce:=true;
  															  end;
{difference}															
															10:begin
{$ifdef Log}
																	 if TriLog then
	                         	    		 WriteLN(STDERR,'difference');
{$endif}
  																 actual[1]:=start^.move_to('V3D',3,'>');
  																 actual[2]:=actual[1]^.next^.move_to('V3D',1,'>');
  																 pv3dobj(actual[1])^.c^.change_size(cl_maximize);
  																 pv3dobj(actual[2])^.c^.change_size(cl_maximize);
  																 shape:=sub_shape(pv3dobj(actual[1])^.c,pv3dobj(actual[2])^.c);
  																 if Assigned(shape) then begin
    																 pv3dobj(actual[1])^.c:=NIL;
    																 pv3dobj(actual[2])^.c:=NIL;
     																 new_3d_elem:=new(pv3dobj,init('V3D',NIL,shape));
        														 WriteLN('3D Objects subtracted: ',shape^.name);
     																 add_chain(actual[1],new_3d_elem,'<');
   																 end;
   																 del_chain(actual[1],actual[2]);
   																 reduce:=true;
															   end;
{intersection}															
															11:begin
{$ifdef Log}
																	 if TriLog then
                          	    	 	 WriteLN(STDERR,'intersection');
{$endif}
  																 actual[1]:=start^.move_to('V3D',3,'>');
  																 actual[2]:=actual[1]^.next^.move_to('V3D',1,'>');
  																 pv3dobj(actual[1])^.c^.change_size(cl_maximize);
  																 pv3dobj(actual[2])^.c^.change_size(cl_maximize);
  																 shape:=inter_shape(pv3dobj(actual[1])^.c,pv3dobj(actual[2])^.c);
  																 if Assigned(shape) then begin
    																 pv3dobj(actual[1])^.c:=NIL;
    																 pv3dobj(actual[2])^.c:=NIL;
     																 new_3d_elem:=new(pv3dobj,init('V3D',NIL,shape));
        														 WriteLN('3D Objects: intersection: ',shape^.name);
     																 add_chain(actual[1],new_3d_elem,'<');
   																 end;
   																 del_chain(actual[1],actual[2]);
   																 reduce:=true;
															   end;
														end;
  											end;
  										if reduce then
  										  result:=true;
										end;
        					end;
      					end;
    	        end;
    	      end;
    	    end;
    	end;
  end;
{$ifndef FKT_RESULT}
	reduce_operation:=result;
{$endif}
end;

function create_element(t:byte;c:tstring;p:pparsobj):pparsobj;
var int_:tinteger;
		flo_:tfloat;
		vec_:tvector;
		error:integer;
{$ifndef FKT_RESULT}
		result:pparsobj;
{$endif}
begin
  result:=Nil;
	case t of
  	2:begin
  			Val(c,int_,error);
  			if error=0 then
  				result:=New(pintobj,init(element_types[t],p,int_));
  		end;
		3:begin
  			Val(c,flo_,error);
  			if error=0 then
  				result:=New(pfloatobj,init(element_types[t],p,flo_));
  		end;
  	7:result:=New(pseparatorobj,init(element_types[t],p,c));
  	8:result:=New(pbraceobj,init(element_types[t],p,c));
  	1,4..6,9..11,16:result:=New(potherobj,init(element_types[t],p,c));
		12: begin
					error:=0;
					if c='x' then
						vec_:=vec_x
					else if c='y' then
						vec_:=vec_y
					else if c='z' then
						vec_:=vec_z
					else
						error:=1;
					if error=0 then
						result:=New(pvectorobj,init(element_types[t],p,vec_));
				end;
  end;
  last_inserted:=result;
{$ifndef FKT_RESULT}
	create_element:=result;
{$endif}
end;

function pars_new_element(element:tstring):boolean;
var t:byte;
		c:tstring;
		br:pbraceobj;
		processed:boolean;
		testIDX:byte;
		elemcount:byte;
{$ifndef FKT_RESULT}
		result:boolean;
{$endif}
begin
	t:=0;
	result:=false;
	while (t<as_types) and (not result) do begin
		inc(t);
		if pos(element_types[t]+':',element)=1 then begin
			result:=true;
			c:=copy(element,length(element_types[t])+2,length(element));
		end;
	end;
	if result then begin
		if Assigned(element_list) then
			result:=element_list^.append(t,c)
		else begin
			element_list:=create_element(t,c,Nil);
			if not Assigned(element_list) then
				result:=false;
		end;
	end;
	if result then begin
		if Assigned(element_list) and (not element_list^.getnext(0)^.is_expr(true)) then
			reduce_math(element_list^.getnext(0)^.prev);
		if Assigned(element_list) and (element_list^.getnext(0)^.t='BRA') then begin
			br:=pbraceobj(element_list^.getnext(0));
		  if br^.c=')' then
				reduce_brace(element_list^.getnext(0));	
		end;
		processed:=true;
		while processed and Assigned(element_list) do begin
		  processed:=false;
		  testIDX:=1;
		  while (not processed) and (testIDX<=as_reductrules)
		  	and Assigned(element_list^.getnext(0))
		  do begin
		  	last_inserted:=element_list^.getnext(0);
		  	elemcount:=count_elements(reduct_rules[testIDX].r);
		  	if last_inserted^.get_match(elemcount,'','<')=reduct_rules[testIDX].r then
		  	  processed:=reduce_operation(last_inserted,reduct_rules[testIDX].id);
		  	if not processed then
		  	  Inc(testIDX);
{$ifdef Log}
				if TriLog then begin		
  				if processed then
   	    		WriteLN(STDERR,'element chain processed.');
  				if not Assigned(element_list) then
   	    		WriteLN(STDERR,'element_list=Nil.');
  				if not Assigned(last_inserted) then
   	    		WriteLN(STDERR,'last_inserted=Nil.');
   	    	if processed and Assigned(element_list) then begin
   	    		WriteLN(STDERR,'current list of elements:');
   	    	  element_list^.list;
   	    	end;
				end;
{$endif}
		  end;
		end;
	end;
{$ifndef FKT_RESULT}
	pars_new_element:=result;
{$endif}
end;

procedure pars_list;
begin
	if Assigned(element_list) then
		element_list^.list;
	if Assigned(macro_list) then
	  macro_list^.listcontent;
end;

constructor tparsobj.init(t_:telementtypestring;prev_:pparsobj);
begin
	inherited init;
	t:=t_;
	next:=Nil;
	prev:=prev_;
end;

function tparsobj.move_to(t_:telementtypestring;count:byte;dir:char):pparsobj;
{$ifndef FKT_RESULT}
var result:pparsobj;
{$endif}
begin
	result:=nil;
	if count>=1 then begin
  	if (t_<>'') and (t_=t) then
  		result:=@self
  	else
  		if count>1 then begin
  			if dir='>' then begin
  				if Assigned(next) then
  					result:=next^.move_to(t_,count-1,'>');
  			end else
  				if Assigned(prev) then
  					result:=prev^.move_to(t_,count-1,'<');
  		end else
  		  if (t_='') then
  		    result:=@self;
	end;
{$ifndef FKT_RESULT}
	move_to:=result;
{$endif}
end;

function tparsobj.getnext(count:byte):pparsobj;
{$ifndef FKT_RESULT}
var result:pparsobj;
{$endif}
begin
	if count>0 then
  	if count>1 then
  		result:=next^.getnext(count-1)
  	else
  	  result:=@self
	else
		if Assigned(next) then
			result:=next^.getnext(0)
		else
			result:=@self;
{$ifndef FKT_RESULT}
	getnext:=result;
{$endif}
end;

function tparsobj.getnext(t_:telementtypestring;count:byte):pparsobj;
{$ifndef FKT_RESULT}
var result:pparsobj;
{$endif}
begin
	result:=move_to(t_,count,'>');
{$ifndef FKT_RESULT}
	getnext:=result;
{$endif}
end;

function tparsobj.append(t_:byte;c_:telementstring):boolean;
{$ifndef FKT_RESULT}
var result:boolean;
{$endif}
begin
	if Assigned(next) then
	  result:=next^.append(t_,c_)
	else begin
		next:=create_element(t_,c_,@self);
		result:=Assigned(next);
	end;
{$ifndef FKT_RESULT}
	append:=result;
{$endif}
end;

function tparsobj.is_expr(open_brace:boolean):boolean;
{$ifndef FKT_RESULT}
var result:boolean;
{$endif}
begin
	result:=((t='INT') or (t='FLO') or (t='OP') or (t='VEC') or
	  (open_brace and (t='BRA') and (pbraceobj(@self)^.c='(')));
{$ifdef Log}
	if TriLog then begin		
  	if result then
  		WriteLN(STDERR,'math expression')
  	else begin
  		Write(STDERR,'no math expression: t:',t);
  		if t='BRA' then begin
  		  Write(STDERR,' c:|',pbraceobj(@self)^.c,'|');
  		  if open_brace then
  		    Write(STDERR,' open_brace');
  		end;
  		WriteLN(STDERR);
  	end;
  end;
{$endif}	
{$ifndef FKT_RESULT}
	is_expr:=result;
{$endif}
end;

function tparsobj.is_expr:boolean;
begin
	is_expr:=is_expr(false);
end;

function tparsobj.get_match(count:byte;m:tstring;dir:char):tstring;
{$ifndef FKT_RESULT}
var result:tstring;
{$endif}
begin
	result:=m;
	if count>0 then begin
	  case dir of
  		'>':begin
    		    if result<>'' then
        			result:=result+' ';
        		result:=result+t;
        		if Assigned(next) then
        			result:=next^.get_match(count-1,result,dir);
      		end;
      '<':begin
            if result<>'' then
        			result:=' '+result;
        		result:=t+result;
        		if Assigned(prev) then
        			result:=prev^.get_match(count-1,result,dir);
      		end;
    end;
	end;
{$ifndef FKT_RESULT}
	get_match:=result;
{$endif}
end;

function tparsobj.get_match(count:byte;m:tstring):tstring;
begin
  get_match:=get_match(count,m,'>');
end;

procedure tparsobj.list;
begin
	write(t);
	listcontent;
	writeln;
	if Assigned(next) then
	  next^.list;
end;

procedure tparsobj.listcontent;
begin
end;

procedure tparsobj.logcontent;
begin
end;

function tparsobj.duplicate(prev_:pparsobj;count:byte):pparsobj;
var newcount:byte;
{$ifndef FKT_RESULT}
    result:pparsobj;
{$endif}
begin
  result:=new(pparsobj,init(t,prev_));
  if ((count>1) or (count=0)) and Assigned(next) then begin
    newcount:=count;
    if newcount>1 then
      dec(newcount);
    result^.next:=next^.duplicate(result,newcount);
  end;
{$ifndef FKT_RESULT}
  duplicate:=result;
{$endif}
end;

destructor tparsobj.done;
begin
{$ifdef Log}
	if TriLog then begin		
  	Write(StdErr,'Done (',t,'): ');
    logcontent;
  	WriteLN(StdErr);
  end;
{$endif}	
	if Assigned(next) then
	  Dispose(next,done);
	inherited done;
end;

constructor tintobj.init(t_:telementtypestring;prev_:pparsobj;c_:tinteger);
begin
	inherited init(t_,prev_);
	c:=c_;
end;

procedure tintobj.listcontent;
begin
	write(c);
end;

procedure tintobj.logcontent;
begin
	write(STDERR,c);
end;

function tintobj.duplicate(prev_:pparsobj;count:byte):pparsobj;
var newcount:byte;
{$ifndef FKT_RESULT}
    result:pparsobj;
{$endif}
begin
  result:=new(pintobj,init(t,prev_,c));
  if ((count>1) or (count=0)) and Assigned(next) then begin
    newcount:=count;
    if newcount>1 then
      dec(newcount);
    result^.next:=next^.duplicate(result,newcount);
  end;
{$ifndef FKT_RESULT}
  duplicate:=result;
{$endif}
end;

constructor tfloatobj.init(t_:telementtypestring;prev_:pparsobj;c_:tfloat);
begin
	inherited init(t_,prev_);
	c:=c_;
end;

procedure tfloatobj.listcontent;
begin
	write(c:0:4);
end;

procedure tfloatobj.logcontent;
begin
	write(STDERR,c:0:4);
end;

function tfloatobj.duplicate(prev_:pparsobj;count:byte):pparsobj;
var newcount:byte;
{$ifndef FKT_RESULT}
    result:pparsobj;
{$endif}
begin
  result:=new(pfloatobj,init(t,prev_,c));
  if ((count>1) or (count=0)) and Assigned(next) then begin
    newcount:=count;
    if newcount>1 then
      dec(newcount);
    result^.next:=next^.duplicate(result,newcount);
  end;
{$ifndef FKT_RESULT}
  duplicate:=result;
{$endif}
end;

constructor tbraceobj.init(t_:telementtypestring;prev_:pparsobj;c_:tbracestring);
begin
	inherited init(t_,prev_);
	c:=c_;
end;
		 						
procedure tbraceobj.listcontent;
begin
	write(c);
end;

procedure tbraceobj.logcontent;
begin
	write(STDERR,c);
end;

function tbraceobj.get_match(count:byte;m:tstring;dir:char):tstring;
{$ifndef FKT_RESULT}
var result:tstring;
{$endif}
begin
	result:=m;
	if count>0 then begin
	  case dir of
  		'>':begin
    		    if result<>'' then
        			result:=result+' ';
        		result:=result+c;
        		if Assigned(next) then
        			result:=next^.get_match(count-1,result,dir);
      		end;
      '<':begin
            if result<>'' then
        			result:=' '+result;
        		result:=c+result;
        		if Assigned(prev) then
        			result:=prev^.get_match(count-1,result,dir);
      		end;
    end;
	end;
{$ifndef FKT_RESULT}
	get_match:=result;
{$endif}
end;

function tbraceobj.duplicate(prev_:pparsobj;count:byte):pparsobj;
var newcount:byte;
{$ifndef FKT_RESULT}
    result:pparsobj;
{$endif}
begin
  result:=new(pbraceobj,init(t,prev_,c));
  if ((count>1) or (count=0)) and Assigned(next) then begin
    newcount:=count;
    if newcount>1 then
      dec(newcount);
    result^.next:=next^.duplicate(result,newcount);
  end;
{$ifndef FKT_RESULT}
  duplicate:=result;
{$endif}
end;

constructor tseparatorobj.init(t_:telementtypestring;prev_:pparsobj;c_:tbracestring);
begin
	inherited init(t_,prev_);
	c:=c_;
end;
		 						
procedure tseparatorobj.listcontent;
begin
	write(c);
end;

procedure tseparatorobj.logcontent;
begin
	write(STDERR,c);
end;

function tseparatorobj.get_match(count:byte;m:tstring;dir:char):tstring;
{$ifndef FKT_RESULT}
var result:tstring;
{$endif}
begin
	result:=m;
	if count>0 then begin
	  case dir of
  		'>':begin
    		    if result<>'' then
        			result:=result+' ';
        		result:=result+c;
        		if Assigned(next) then
        			result:=next^.get_match(count-1,result,dir);
      		end;
      '<':begin
            if result<>'' then
        			result:=' '+result;
        		result:=c+result;
        		if Assigned(prev) then
        			result:=prev^.get_match(count-1,result,dir);
      		end;
    end;
	end;
{$ifndef FKT_RESULT}
	get_match:=result;
{$endif}
end;

function tseparatorobj.duplicate(prev_:pparsobj;count:byte):pparsobj;
var newcount:byte;
{$ifndef FKT_RESULT}
    result:pparsobj;
{$endif}
begin
  result:=new(pseparatorobj,init(t,prev_,c));
  if ((count>1) or (count=0)) and Assigned(next) then begin
    newcount:=count;
    if newcount>1 then
      dec(newcount);
    result^.next:=next^.duplicate(result,newcount);
  end;
{$ifndef FKT_RESULT}
  duplicate:=result;
{$endif}
end;

constructor tvectorobj.init(t_:telementtypestring;prev_:pparsobj;c_:tvector);
begin
	inherited init(t_,prev_);
	c:=c_;
end;

procedure tvectorobj.listcontent;
begin
	write('<',c.x:0:4,',',c.y:0:4,',',c.z:0:4,'>');
end;

procedure tvectorobj.logcontent;
begin
	write(STDERR,'<',c.x:0:4,',',c.y:0:4,',',c.z:0:4,'>');
end;

function tvectorobj.duplicate(prev_:pparsobj;count:byte):pparsobj;
var newcount:byte;
{$ifndef FKT_RESULT}
    result:pparsobj;
{$endif}
begin
  result:=new(pvectorobj,init(t,prev_,c));
  if ((count>1) or (count=0)) and Assigned(next) then begin
    newcount:=count;
    if newcount>1 then
      dec(newcount);
    result^.next:=next^.duplicate(result,newcount);
  end;
{$ifndef FKT_RESULT}
  duplicate:=result;
{$endif}
end;

constructor ttransobj.init(t_:telementtypestring;prev_:pparsobj;tr_ro_:char;c_:tvector);
begin
	inherited init(t_,prev_);
	tr_ro:=tr_ro_;
	c:=c_;
end;

procedure ttransobj.listcontent;
begin
  case tr_ro of
    't':write('translation ');
    'r':write('rotation ');
    else write('??? ');
  end;
	write('<',c.x:0:4,',',c.y:0:4,',',c.z:0:4,'>');
end;

procedure ttransobj.logcontent;
begin
  case tr_ro of
    't':write(STDERR,'translation ');
    'r':write(STDERR,'rotation ');
    else write(STDERR,'??? ');
  end;
	write(STDERR,'<',c.x:0:4,',',c.y:0:4,',',c.z:0:4,'>');
end;

function ttransobj.duplicate(prev_:pparsobj;count:byte):pparsobj;
var newcount:byte;
{$ifndef FKT_RESULT}
    result:pparsobj;
{$endif}
begin
  result:=new(ptransobj,init(t,prev_,tr_ro,c));
  if ((count>1) or (count=0)) and Assigned(next) then begin
    newcount:=count;
    if newcount>1 then
      dec(newcount);
    result^.next:=next^.duplicate(result,newcount);
  end;
{$ifndef FKT_RESULT}
  duplicate:=result;
{$endif}
end;

constructor totherobj.init(t_:telementtypestring;prev_:pparsobj;c_:tstring);
begin
	inherited init(t_,prev_);
	c:=c_;
end;

procedure totherobj.listcontent;
begin
	write(c);
end;

procedure totherobj.logcontent;
begin
	write(STDERR,c);
end;

function totherobj.duplicate(prev_:pparsobj;count:byte):pparsobj;
var newcount:byte;
{$ifndef FKT_RESULT}
    result:pparsobj;
{$endif}
begin
  result:=new(potherobj,init(t,prev_,c));
  if ((count>1) or (count=0)) and Assigned(next) then begin
    newcount:=count;
    if newcount>1 then
      dec(newcount);
    result^.next:=next^.duplicate(result,newcount);
  end;
{$ifndef FKT_RESULT}
  duplicate:=result;
{$endif}
end;

constructor tv3dobj.init(t_:telementtypestring;prev_:pparsobj;c_:pshape_3d);
begin
	inherited init(t_,prev_);
	c:=c_;
end;

procedure tv3dobj.listcontent;
begin
  if Assigned(c) then
  	write(' ',c^.name,':',c^.count,' triangles');
end;

procedure tv3dobj.logcontent;
begin
  if Assigned(c) then
  	write(STDERR,' ',c^.name,':',c^.count,' triangles')
  else
  	write(STDERR,'Nil')
end;

function tv3dobj.duplicate(prev_:pparsobj;count:byte):pparsobj;
var newcount:byte;
{$ifndef FKT_RESULT}
    result:pparsobj;
{$endif}
begin
  result:=new(pv3dobj,init(t,prev_,c^.clone_shape(c^.name)));
  if ((count>1) or (count=0)) and Assigned(next) then begin
    newcount:=count;
    if newcount>1 then
      dec(newcount);
    result^.next:=next^.duplicate(result,newcount);
  end;
{$ifndef FKT_RESULT}
  duplicate:=result;
{$endif}
end;

destructor tv3dobj.done;
begin
  if Assigned(c) then
  	dispose(c,done);
  c:=Nil;
  inherited done;
end;
		 						
constructor tmacro.init(name_:tstring;prev_:pmacro;list_:pparsobj;count:byte);
begin
  inherited init;
  name:=name_;
  next:=nil;
  prev:=prev_;
  if Assigned(prev) then
    prev^.next:=@self;
  if Assigned(list_) then
    list:=list_^.duplicate(nil,count)
  else
    list:=nil;
{$ifdef Log}
	if TriLog then begin		
    Write(STDERR,'macro ',name,' created. ');
    if Assigned(list) then
      WriteLN(STDERR,'Object list duplicated.')
    else
      WriteLN(STDERR,'No object list given.');
  end;
{$endif}
end;

function tmacro.by_name(name_:tstring):pmacro;
{$ifndef FKT_RESULT}
var result:pmacro;
{$endif}
begin
  if name_=name then
    result:=@self
  else
    if Assigned(next) then
      result:=next^.by_name(name_)
    else
      result:=nil;
{$ifndef FKT_RESULT}
  by_name:=result;
{$endif}
end;

function tmacro.duplicate:pparsobj;
{$ifndef FKT_RESULT}
var result:pparsobj;
{$endif}
begin
  result:=nil;
  if assigned(list) then
    result:=list^.duplicate(nil,0);
{$ifndef FKT_RESULT}
  duplicate:=result;
{$endif}
end;

function tmacro.apply(instead:pparsobj):pparsobj;
var start,stop:pparsobj;
{$ifndef FKT_RESULT}
    result:pparsobj;
{$endif}
begin
  if Assigned(instead) then begin
    start:=duplicate;
    if Assigned(start) then begin
      stop:=start^.getnext(0);
      start^.prev:=instead^.prev;
      stop^.next:=instead^.next;
      if Assigned(start^.prev) then
        start^.prev^.next:=start;
      if Assigned(stop^.next) then
        stop^.next^.prev:=stop;
      instead^.next:=nil;
      dispose(instead,done);
      result:=start;
    end else begin
      if Assigned(instead^.next) then
        instead^.next^.prev:=instead^.prev;
      if Assigned(instead^.prev) then
        instead^.prev^.next:=instead^.next;
      instead^.next:=nil;
      dispose(instead,done);
      result:=nil;
    end;
  end;
{$ifndef FKT_RESULT}
  apply:=result;
{$endif}
end;

procedure tmacro.listcontent;
begin
  writeln('-');
  writeln('macro ',name,': ');
  if Assigned(list) then
    list^.list;
  if Assigned(next) then
    next^.listcontent;
end;

destructor tmacro.done;
begin
{$ifdef Log}
	if TriLog then
		WriteLN(StdErr,'Done (Makro): ',name);
{$endif}	
  if Assigned(list) then
    dispose(list,done);
  if Assigned(next) then
    dispose(next,done);
  inherited done;
end;

initialization
	element_list:=NIL;
	last_inserted:=NIL;
	macro_list:=NIL;
	macro_init;

finalization
	if Assigned(element_list) then begin
		dispose(element_list,Done);
		element_list:=Nil;
	end;
	if Assigned(macro_list) then begin
		dispose(macro_list,Done);
		macro_list:=Nil;
	end;
end.
