// test.pov: Test- und Demoscript fuer die
// Erzeugung triangulierter Oberflaechen aus PovRay-Quellen

#include "colors.inc"
#include "textures.inc"


// Variablendeklarationen (geometrische Abmessungen)
#declare Breite = 5;
#declare Hoehe = 3;
#declare Laenge = 10;
#declare D_Breite = 4;
#declare D_Hoehe = 2;
#declare D_Laenge = 7;
#declare Radius = 3;

camera {
    location <-20*Laenge, 100*Hoehe, Laenge>
    look_at <Breite+D_Breite,Hoehe,Laenge>
    angle 5
}

light_source { <-500, 500, -500> White }
light_source { <-300, 1500, 500> White }

plane { y, -.1
	texture {
    	pigment { White }
		finish { ambient 1 }
	}
}


// Makrodeklaration fuer Quader
#declare Quader = box {
    <0, 0, 0> <Breite,Hoehe,Laenge>
}

// Makrodeklaration fuer Zylinder
#declare Zylinder = cylinder {
    <0,-Hoehe,0> <0,2*Hoehe+D_Hoehe,0> Radius
}

// Addierte Quader mit ausgeschnittenem Zylinderstueck
difference {
  union {
    object { Quader pigment { Red } }
    object { Quader translate <D_Breite,D_Hoehe,D_Laenge> pigment { Blue } }
  }

  object { Zylinder translate <0,0,0> }
}

// Freistehender Zylinder
object { Zylinder translate <2*Breite+D_Breite,0,0> pigment { Gray } }
