{
Pov2Tri
povray model to triangulated shape converter

program author
Arndt Kritzner, see http://www.kritzner.de

version
0.5 ... 2003-01-18

licenses:
volume3d is available under the terms of GNUs GPL (for developers of free software,
only FreePascal or GNU Pascal with Linux) or alternatively under a commercial
license (for developers of commercial software)

All rights reserved.
Any usage in another kind than described in the purchased license is prohibited.
If you want to choose the GNU GPL on another platform than GNU/Linux ask for a
free license for your preferred OS mailto:arndt@kritzner.de.

See http://www.kritzner.de/pages/v3d/v3d.html for technical and licensing details.
}

{
povparse.pp
parser for povray files
}

program povparse;
uses triangle3d,form3d,export3d,povparser;
type TParam=(inp,gts,stl,facet,none);
const	Param:array[TParam] of string=('','','','','');
var LexInput:Text;
		Zeile:String;
		Is_File,Error:boolean;
		shape:pshape_3d;
		idx:byte;
		ParamString:string;
		ParamType:TParam;
		Value:float3d;
		ValError:Integer;
begin
	Is_File:=false;
	Error:=false;
	if ParamCount>0 then begin
	  for idx:=1 to ParamCount do begin
	    ParamType:=none;
	    if pos('-input=',ParamStr(idx))=1 then begin
        ParamType:=inp;
        ParamString:=copy(ParamStr(idx),Length('-input=')+1,Length(ParamStr(idx)));	
	    end;
	    if pos('-gts=',ParamStr(idx))=1 then begin
        ParamType:=gts;
        ParamString:=copy(ParamStr(idx),Length('-gts=')+1,Length(ParamStr(idx)));	
	    end;
	    if pos('-stl=',ParamStr(idx))=1 then begin
        ParamType:=stl;
        ParamString:=copy(ParamStr(idx),Length('-stl=')+1,Length(ParamStr(idx)));	
	    end;
	    if pos('-facet-angle=',ParamStr(idx))=1 then begin
        ParamType:=facet;
        ParamString:=copy(ParamStr(idx),Length('-facet-angle=')+1,Length(ParamStr(idx)));	
	    end;
	    if ParamType in [inp,gts,stl,facet] then
	      Param[ParamType]:=ParamString;
		end;
	end;
	if Param[facet]<>'' then begin
	  Val(Param[facet],Value,ValError);
	  if ValError=0 then begin
			if Value<5 then Value:=5;
			if Value>45 then Value:=45;	
			WriteLN(StdErr,'Facet precision set to ',Value:0:2,' deg');
	    Value:=Value*pi/180;
	    facet_precision:=Value;
	  end;
	end;
  if Param[inp]<>'' then begin
    writeln('Input from ',Param[inp]);
		Assign(LexInput,Param[inp]);
		{$i-}
		Reset(LexInput);
		{$i+}
		if IOResult<>0 then
			Error:=true;
		Is_File:=true;
	end	else
		LexInput:=Input;
	if Error then
		WriteLN(StdErr,'Error opening input file. Program exits.')
	else begin
  	while not EOF(LexInput) do begin
  		ReadLN(LexInput,Zeile);
  		pars_new_element(Zeile);
  	end;
  	pars_new_element('STOP:');
  	if Is_File then
  		Close(LexInput);
  	pars_list;
  	shape:=unite_v3d;
  	if assigned(shape) then begin
  	  if Param[gts]<>'' then begin
  	    writeln('GTS export to ',Param[gts]);
  	    if not export_gts(shape,Param[gts]) then
  	      Writeln('Error writing gts export file');
  	  end;
  	  if Param[stl]<>'' then begin
  	    writeln('STL export to ',Param[stl]);
  	    if not export_stl(shape,Param[stl]) then
  	      Writeln('Error writing stl export file');
  	  end;
  	  dispose(shape,done);
  	end;
	end;
end.
